-- Devices table
CREATE TABLE IF NOT EXISTS devices (
  id serial PRIMARY KEY,
  org_key varchar NOT NULL,
  allowed boolean DEFAULT false NOT NULL,
  first_seen timestamp NOT NULL,
  last_seen timestamp NOT NULL,
  vendor_name varchar NOT NULL,
  vendor_id numeric NOT NULL,
  model_name varchar NOT NULL,
  model_id varchar NOT NULL,
  serial_number varchar NOT NULL,
  user_name varchar NOT NULL,
  user_id varchar NOT NULL,
  sensor_name varchar NOT NULL,
  sensor_id numeric NOT NULL,
  device_type varchar NOT NULL,
  interface_type varchar NOT NULL,
  device_friendly_name varchar NOT NULL,
  filesystem_type varchar NOT NULL,
  volume_serial_number numeric NOT NULL,
  device_name varchar NOT NULL,
  created_at timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
  updated_at timestamp NOT NULL
);

CREATE UNIQUE INDEX devices_serial_org_vendor_model_idx on devices (org_key, serial_number, vendor_id, model_id);

CREATE INDEX devices_org_idx on devices (org_key);

-- Orgs table
CREATE TABLE IF NOT EXISTS orgs (
  id serial PRIMARY KEY,
  org_key varchar UNIQUE NOT NULL,
  enabled boolean DEFAULT true NOT NULL,
  block_all boolean DEFAULT false NOT NULL,
  created_at timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
  updated_at timestamp NOT NULL
);

CREATE INDEX orgs_org_idx on orgs (org_key);
