-- rule_type enum
BEGIN;

CREATE TYPE enum_rule_type AS ENUM (
       'device',
       'device_category'
);

COMMIT;

-- device_rules table
CREATE TABLE IF NOT EXISTS device_rules (
id serial PRIMARY KEY,
org_key varchar NOT NULL,
vendor_id varchar NOT NULL,
product_id varchar NOT NULL,
serial_number varchar NOT NULL,
sync_status enum_sync_status DEFAULT 'queued',
rule_type enum_rule_type NOT NULL,
rule_guid uuid NOT NULL,
allowed boolean DEFAULT true NOT NULL,
rule_name varchar,
notes varchar,
updated_by varchar NOT NULL,
created_at timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
updated_at timestamp NOT NULL,
deleted_at timestamp,

-- org_key foreign key constraint
CONSTRAINT constraint_device_rules_orgs_fk FOREIGN KEY (org_key) REFERENCES orgs(org_key) ON DELETE CASCADE
);

CREATE UNIQUE INDEX device_rules_serial_org_vendor_product_idx on device_rules (org_key, serial_number, vendor_id, product_id);
