-- policy_rules table
CREATE TABLE IF NOT EXISTS policy_rules (
id serial PRIMARY KEY,
org_key varchar NOT NULL,
policy_id varchar NOT NULL,
sync_status enum_sync_status DEFAULT 'queued',
block_all boolean DEFAULT true NOT NULL,
created_at timestamp DEFAULT CURRENT_TIMESTAMP NOT NULL,
updated_at timestamp NOT NULL,
deleted_at timestamp,

-- org_key foreign key constraint
CONSTRAINT constraint_policy_rules_orgs_fk FOREIGN KEY (org_key) REFERENCES orgs(org_key) ON DELETE CASCADE
);

CREATE UNIQUE INDEX policy_rules_org_policy_idx on policy_rules (org_key, policy_id);
