CREATE TABLE IF NOT EXISTS org_vendors(
  id SERIAL PRIMARY KEY,
  created_at TIMESTAMP DEFAULT CURRENT_TIMESTAMP NOT NULL,
  updated_at TIMESTAMP NOT NULL,
  deleted_at TIMESTAMP,
  org_key VARCHAR NOT NULL,
  vendor_id NUMERIC NOT NULL,
  vendor_name VARCHAR NOT NULL
);
CREATE UNIQUE INDEX IF NOT EXISTS org_vendor_org_key_vendor_idx ON org_vendors(org_key, vendor_id);

CREATE TABLE IF NOT EXISTS org_products(
  id SERIAL PRIMARY KEY,
  created_at TIMESTAMP DEFAULT CURRENT_TIMESTAMP NOT NULL,
  updated_at TIMESTAMP NOT NULL,
  deleted_at TIMESTAMP,
  org_key VARCHAR NOT NULL,
  vendor_id NUMERIC NOT NULL,
  product_id NUMERIC NOT NULL,
  product_name VARCHAR NOT NULL,
  CONSTRAINT constraint_org_product_org_vendor_fk FOREIGN KEY (org_key, vendor_id) REFERENCES org_vendors(org_key, vendor_id) ON DELETE CASCADE
);
CREATE UNIQUE INDEX IF NOT EXISTS org_product_org_key_vendor_product_idx ON org_products(org_key, vendor_id, product_id);

ALTER TABLE devices ALTER COLUMN product_id TYPE NUMERIC USING (product_id::NUMERIC);
